/****** Menus Routines ***************/
#include "Menu.h"
#include "Text.h"

char UpCase (char dati)
{
	if ((dati > 0x60) && (dati < 0x7B)) dati -= 0x20;
	return dati;
	
}	

//void xTxtDisp (char nbrchar,char Line,char MsgIdx, char font,bit Upper,bit Reverse)
//{
//}				
void TxtDisp (char nbrchar, char Line,size2 const char *Msgi,uns16 ofs,char font, bit Upper,bit Reverse)
{
	char i,j,k,l;
	
	size2 const char *ptr = Msgi;
	

//	ofs = 0;	
	ptr += ofs;
	for (i=0;i!=nbrchar;i++)
	{
		k = *ptr;
		ptr++;
		if (Upper) k=UpCase(k);
		txt[i] = k;
	}
	txt[nbrchar] = 0;
	LCDK_PrintLine(font,0,Line,Reverse);
	
}
/*
void TxtDispExt (char nbrchar,char Line,char MsgIdx,char font,bit Upper,bit Reverse)
{
	char i,j,k,l;
	
	j = MenuIdxE[MsgIdx];
	for (i=0;i!=nbrchar;i++)
	{
		l = i + j;
		k = MenuTxtE[l];
		if (Upper) k=UpCase(k);
		txt[i] = k;
	}
	txt[nbrchar] = 0;
	LCDK_PrintLine(font,0,Line,Reverse);
	
}
*/
uns16 EnterValue(char x,char y,char nbrdigits,uns16 min,uns16 max,uns16 step,uns16 def)
{
	uns16 val,i,j;
	uns16 mxsteps,minstep;
	char svrot;
	
	svrot = upcntr;
	val = def;
	cvhexbcd (val);	
	mxsteps = max - min;
	mxsteps /= step;
	mxsteps ++;
	minstep = min/step;
	if (val != 0) val--;
	i = val/step;
	upcntr = minstep + i; 
	dispval (x,y,nbrdigits,0,1);
	RselSWchg = 0;
	while (RselSWchg !=1)
	{
		//HandelRotary();
		if (msflg)
		{
			ADCModule(0);
			msflg =0;
		}	
		if (Rselchg == 1)
		{
			Rselchg = 0;
			if (upcntr > mxsteps) upcntr = mxsteps;
			if (upcntr < minstep) upcntr = minstep;
			i = upcntr * step;
			val = i;
			cvhexbcd (val);
			dispval (x,y,nbrdigits,0,1);

		}
	}
	RselSWchg = 0;
	upcntr = svrot;	
	
	return val;
}

uns16 EnterInpValue(char x,char y,char nbrdigits,char def)
{
	uns16 val,i,j;
	uns16 mxsteps,minstep;
	char svrot,rcntr;
	
	svrot = upcntr;
	val = def;
	cvhexbcd (val);	
	mxsteps = 4;
	minstep = 1;
	upcntr = def;
	rcntr = def;
	dispval (x,y,nbrdigits,0,1);
	RselSWchg = 0;
	while (RselSWchg !=1)
	{
		//HandelRotary();
		if (msflg)
		{
			ADCModule(0);
			msflg =0;
		}	
		if (Rselchg == 1)
		{
			Rselchg = 0;
			if (upcntr == 3) 		// skip entrie 3
			{
				if (rcntr == 2)
				{
					upcntr = 4;
					rcntr = 4;
				}
				else 
				{
					upcntr = 2;
					rcntr = 2;
				}		
				
			}
			else
			{	 
				if (upcntr > 4) upcntr = 4;
				if (upcntr < 1) upcntr = 1;
				i = upcntr;
				rcntr = upcntr;
				val = i;
			}	
			cvhexbcd (val);
			dispval (x,y,nbrdigits,0,1);
		}
	}
	RselSWchg = 0;
	upcntr = svrot;	
	return val;
}
	
void InitMenu (bit md)
{

	size2 const char *point = MenuTxt[0].pt1;
	
	while (RotaryDebounce != 0); 
	while (SELSW == 0);	// first wait release of switch
	LCDK_Cls(0x00);
	upcntr = 0;
	point = MenuTxt[0].pt1;
	TxtDisp (14,0,point,0,2,0,0);
	TxtDisp (18,2,point,14,1,0,1);
	TxtDisp (13,3,point,32,1,0,0);
	TxtDisp (16,4,point,45,1,0,0);
	TxtDisp (14,5,point,61,1,0,0);
	TxtDisp (18,7,point,75,1,0,0);
	mnstat = 0;			
	MenuItem =0;
	OpsStart = 1;
	OpsMode = 1;
//	OpsComplete = 0;
}

/************************************************
	Menu
- MenuStat = 0 is line selection in the main menu
- MenuStat = 1 is line selection in secondary menus
Menustat changed from 0 to 1 by pressing button 
- MenuItem is unique position in any selection
- Opsmode is the routine that will execute 
**************************************************/
void Menu (void)
{
	uns16 calc;
	size2 const char *point = MenuTxt[0].pt1;
	
	// ************* Process lines selections by rotery ****
	// each selection rewrite above and under line in normal
	// and print the sected line in reverse video
	// ******************************** 
	if (Rselchg == 1)
	{
		Rselchg = 0;
		if (mnstat == 0)	// mesure capacite	
		{
			if (upcntr == 4) upcntr = 3;
			switch (upcntr)
			{
				case 0:
				{
					TxtDisp (18,2,point,14,1,0,1);
					TxtDisp (13,3,point,32,1,0,0);
					MenuItem = 0;
					OpsMode = 1;
					break; 
				}
				case 1:
				{
					TxtDisp (18,2,point,14,1,0,0);
					TxtDisp (13,3,point,32,1,0,1);
					TxtDisp (16,4,point,45,1,0,0);	
					MenuItem = 1;
					OpsMode = 2;
					break;
				}
				case 2:
				{
					TxtDisp (13,3,point,32,1,0,0);
					TxtDisp (16,4,point,45,1,0,1);	
					TxtDisp (14,5,point,61,1,0,0);
					MenuItem = 2;
					OpsMode = 3;		// mode 3 if implemented
					break;
				}
				case 3:
				{
					TxtDisp (16,4,point,45,1,0,0);	
					TxtDisp (14,5,point,61,1,0,1);
					MenuItem = 3;
					OpsMode = 4;
					break;
				}	
					
			}				
		}
		else if (mnstat == 1)	// Capacity mesaure
		{
			if (upcntr == 4) upcntr = 3;
			switch (upcntr)
			{
				case 0:
				{
					TxtDisp (13,0,point,93,1,0,1);
					TxtDisp (16,1,point,106,1,0,0);
					MenuItem = 10;
					break; 
				}
				case 1:
				{
					TxtDisp (13,0,point,93,1,0,0);
					TxtDisp (16,1,point,106,1,0,1);
					TxtDisp (14,2,point,122,1,0,0);	
					MenuItem = 11;
					break;
				}
				case 2:
				{
					TxtDisp (16,1,point,106,1,0,0);
					TxtDisp (14,2,point,122,1,0,1);
					TxtDisp (14,3,point,0,1,1,0);	
					MenuItem = 12;
					break;
				}
				case 3:
				{
					TxtDisp (14,2,point,122,1,0,0);
					TxtDisp (14,3,point,0,1,1,1);	
					MenuItem = 13;
				}		
			}	
		}
		else if (mnstat == 2)	// Storage
		{
			if (upcntr == 4) upcntr = 3;
			switch (upcntr)
			{
				case 0:
				{
					TxtDisp (13,0,point,93,1,0,1);
					TxtDisp (16,1,point,106,1,0,0);
					MenuItem = 20;
					break; 
				}
				case 1:
				{
					TxtDisp (13,0,point,93,1,0,0);
					TxtDisp (16,1,point,106,1,0,1);
					TxtDisp (14,2,point,122,1,0,0);	
					MenuItem = 21;
					break;
				}
				case 2:
				{
					TxtDisp (16,1,point,106,1,0,0);
					TxtDisp (14,2,point,122,1,0,1);
					TxtDisp (14,3,point,0,1,1,0);	
					MenuItem = 22;
					break;
				}
				case 3:
				{
					TxtDisp (14,2,point,122,1,0,0);
					TxtDisp (14,3,point,0,1,1,1);	
					MenuItem = 23;
				}		
			}
		}
		else if (mnstat == 3)	//Resistance
		{
			if (upcntr == 3) upcntr = 2;
			switch (upcntr)
			{
				case 0:
				{
					TxtDisp (16,0,point,106,1,0,1);
					TxtDisp (14,1,point,122,1,0,0);
					MenuItem = 30;
					break;
				}
				case 1:
				{
					TxtDisp (16,0,point,106,1,0,0);
					TxtDisp (14,1,point,122,1,0,1);
					TxtDisp (14,2,point,0,1,1,0);
					MenuItem = 31;
					break;
				}
				case 2:
				{
					TxtDisp (14,1,point,122,1,0,0);
					TxtDisp (14,2,point,0,1,1,1);
					MenuItem = 32;
					break;
				}					
			}		
		}
		else if (mnstat == 4)	//calibration
		{
			if (upcntr == 5) upcntr = 4;
			switch (upcntr)
			{
				case 0:
				{
					TxtDisp (11,0,point,227,1,0,1);	
					TxtDisp (12,1,point,238,1,0,0);
					MenuItem = 40;
					break; 
				}
				case 1:
				{
					if (ClrLineFlg == 1)
					{
						LCDK_ClrTxtLine(5);
						ClrLineFlg = 0;
					}	
					TxtDisp (11,0,point,227,1,0,0);	
					TxtDisp (12,1,point,238,1,0,1);
					TxtDisp (15,2,point,334,1,0,0);
					MenuItem = 41;
					Inputs = 1;
					break;
				}
				case 2:
				{		
					TxtDisp (12,1,point,238,1,0,0);
					TxtDisp (15,2,point,334,1,0,1);
					TxtDisp (14,3,point,366,1,0,0);
					MenuItem = 42;
					break;
				}
				case 3:
				{
					TxtDisp (15,2,point,334,1,0,0);
					TxtDisp (14,3,point,366,1,0,1);
					TxtDisp (14,4,point,0,1,1,0);
					Current = 1000;
					MenuItem = 43;
					break;
				}	
				case 4:
				{
					TxtDisp (14,3,point,366,1,0,0);
					TxtDisp (14,4,point,0,1,1,1);
					if (ClrLineFlg == 1)
					{
						LCDK_ClrTxtLine(5);
						ClrLineFlg = 0;
					}
					MenuItem = 44;	
					break;
				}	
			}
		}				
	}
	// ************** Process Bouton pushed **************
	if (RselSWchg == 1)
	{
		

		switch (MenuItem)	 
		{
			case 0:
			{
				mnstat = 1;	//menu test capacity
				upcntr = 0;
				LCDK_Cls(0x00);
				TxtDisp (13,0,point,93,1,0,1);
				TxtDisp (16,1,point,106,1,0,0);
				TxtDisp (14,2,point,122,1,0,0);	
				TxtDisp (14,3,point,0,1,1,0);	
				MenuItem = 10;

				break;
			}
			case 1:
			{
				mnstat = 2;	//menu storage
				upcntr = 0;
				LCDK_Cls(0x00);
				TxtDisp (13,0,point,93,1,0,1);	
				TxtDisp (16,1,point,106,1,0,0);
				TxtDisp (14,2,point,122,1,0,0);
				TxtDisp (14,3,point,0,1,1,0);	
				MenuItem = 20;
				break;
			}
			case 2:
			{
				mnstat = 3;	//menu resistance
				upcntr = 0;
				LCDK_Cls(0x00);
				TxtDisp (16,0,point,106,1,0,1);
				TxtDisp (14,1,point,122,1,0,0);
				TxtDisp (14,2,point,0,1,1,0);	
				break;
			}
			case 3:
			{
				mnstat = 4;	//menu calibration
				upcntr = 0;
				LCDK_Cls(0x00);
				TxtDisp (11,0,point,227,1,0,1);	
				TxtDisp (12,1,point,238,1,0,0);
				TxtDisp (15,2,point,334,1,0,0);
				TxtDisp (14,3,point,366,1,0,0);
				TxtDisp (14,4,point,0,1,1,0);
				MenuItem = 40;
				PotInit = 0;
				break;
			}
			case 10:
			{
				
				txt[0]='E';
				txt[1]='n';	
				txt[2]='t';
				txt[3]='r';
				txt[4]='e';
				txt[5]='e';
				txt[6]='(';
				txt[7]='s';
				txt[8]=')';
				txt[9]=0;
				LCDK_ClrTxtLine(5);
				LCDK_PrintLine(1,3,5,0);
				//EnterValue : x,y,nbr digits,min,max,step
				calc = EnterInpValue(1,5,1,Inputs);
				Inputs = calc.low8;
				LCDK_ClrTxtLine(5);
				break;
			}
			case 11:
			{
				txt[0]='E';
				txt[1]='l';	
				txt[2]='e';
				txt[3]='m';
				txt[4]='e';
				txt[5]='n';
				txt[6]='t';
				txt[7]='(';
				txt[8]='s';
				txt[9]=')';
				txt[10]=0;
				LCDK_ClrTxtLine(5);
				LCDK_PrintLine(1,3,5,0);
				//EnterValue : x,y,nbr digits,min,max,step
				calc = EnterValue(1,5,1,1,8,1,Elements);
				Elements = calc.low8;
				LCDK_ClrTxtLine(5);
				break;
			}
			case 12:
			{
				txt[0]=' ';
				txt[1]='A';	
				txt[2]='m';
				txt[3]='p';
				txt[4]='e';
				txt[5]='r';
				txt[6]='e';
				txt[7]='(';
				txt[8]='s';
				txt[9]=')';
				txt[10]=0;
				LCDK_ClrTxtLine(5);
				LCDK_PrintLine(1,7,5,0);
				//EnterValue : x,y,nbr digits,min,max,step
				switch (Inputs)
				{
					case (1):
					{
						calc = 8000;
						break;
					}
					case (2):
					{
						calc = 4000;
						break;
					}
					case (3):
					{
						calc = 2000;
						break;
					}
					case (4) :
					{
						calc = 2000;
						break;
					}			
				}	
				calc = EnterValue(1,5,4,100,calc,100,Current);
				Current = calc;
				LCDK_ClrTxtLine(5);
				break;
			}
			case 13:
			{
				OpsMode = mnstat;
				InitMenu(1);
				break;
			}
			case 20:
			{
				OpsMode = 2;
				txt[0]='E';
				txt[1]='n';	
				txt[2]='t';
				txt[3]='r';
				txt[4]='e';
				txt[5]='e';
				txt[6]='(';
				txt[7]='s';
				txt[8]=')';
				txt[9]=0;
				LCDK_ClrTxtLine(5);
				LCDK_PrintLine(1,3,5,0);
				//EnterValue : x,y,nbr digits,min,max,step
				calc = EnterInpValue(1,5,1,Inputs);
				Inputs = calc.low8;
				LCDK_ClrTxtLine(5);
				break;
			}
			case 21:
			{
				OpsMode = 2;
				txt[0]='E';
				txt[1]='l';	
				txt[2]='e';
				txt[3]='m';
				txt[4]='e';
				txt[5]='n';
				txt[6]='t';
				txt[7]='(';
				txt[8]='s';
				txt[9]=')';
				txt[10]=0;
				LCDK_ClrTxtLine(5);
				LCDK_PrintLine(1,3,5,0);
				//EnterValue : x,y,nbr digits,min,max,step
				calc = EnterValue(1,5,1,1,8,1,Elements);
				Elements = calc;
				LCDK_ClrTxtLine(5);
				break;
			}
			case 22:
			{
				OpsMode = 2;
				txt[0]='m';
				txt[1]='A';	
				txt[2]='m';
				txt[3]='p';
				txt[4]='e';
				txt[5]='r';
				txt[6]='e';
				txt[7]='s';
				txt[8]=' ';
				txt[9]=' ';
				txt[10]=0;
				LCDK_ClrTxtLine(5);
				LCDK_PrintLine(1,7,5,0);
				//EnterValue : x,y,nbr digits,min,max,step
				switch (Inputs)
				{
					case (1):
					{
						calc = 8000;
						break;
					}
					case (2):
					{
						calc = 4000;
						break;
					}
					case (3):
					{
						calc = 2000;
						break;
					}
					case (4) :
					{
						calc = 2000;
						break;
					}			
				}
				calc = EnterValue(1,5,4,100,calc,100,Current);
				Current = calc;
				LCDK_ClrTxtLine(5);	
				break;
			}
			case 23:
			{
				OpsMode = mnstat;
				InitMenu(1);
				break;
			}

			
			case 30:
			{
				OpsMode = 3;
				txt[0]='E';
				txt[1]='l';	
				txt[2]='e';
				txt[3]='m';
				txt[4]='e';
				txt[5]='n';
				txt[6]='t';
				txt[7]='(';
				txt[8]='s';
				txt[9]=')';
				txt[10]=0;
				LCDK_ClrTxtLine(5);
				LCDK_PrintLine(1,3,5,0);
				//EnterValue : x,y,nbr digits,min,max,step,start val
				calc = EnterValue(1,5,1,1,8,1,Elements);
				Elements = calc.low8;
				LCDK_ClrTxtLine(5);
				break;
			}
			case 31:
			{
				OpsMode = 3;
				txt[0]='m';
				txt[1]='A';	
				txt[2]='m';
				txt[3]='p';
				txt[4]='e';
				txt[5]='r';
				txt[6]='e';
				txt[7]='s';
				txt[8]=':';
				txt[9]=' ';
				txt[10]=0;
				LCDK_ClrTxtLine(5);
				LCDK_PrintLine(1,7,5,0);
				//EnterValue : x,y,nbr digits,min,max,step
				Current = 1000;
				calc = EnterValue(1,5,4,500,1900,100,Current);
				Current = calc;
				LCDK_ClrTxtLine(5);	
				break;	
			}
			case 32:
			{
				OpsMode = mnstat;
				InitMenu(1);
				break;	
			}				
			case 40:
			{
				if (ClrLineFlg == 0)
				{
					OpsMode = 4;
					txt[0]='P';
					txt[1]='a';	
					txt[2]='s';
					txt[3]=' ';
					txt[4]='S';
					txt[5]='e';
					txt[6]='l';
					txt[7]='e';
					txt[8]='c';
					txt[9]='t';
					txt[10]='i';
					txt[11]='o';
					txt[12]='n';
					txt[13]=0;
					LCDK_ClrTxtLine(5);
					LCDK_PrintLine(1,0,5,0);
					ClrLineFlg = 1;
				}
				else
				{
					LCDK_ClrTxtLine(5);
					ClrLineFlg = 0;
				}	
				break;
			}
			case 41:
			{
				txt[0]='=';
				txt[1]='P';	
				txt[2]='O';
				txt[3]='R';
				txt[4]='T';
				txt[5]=' ';
				txt[6]='S';
				txt[7]='e';
				txt[8]='l';
				txt[9]=' ';
				txt[10]=0;
				LCDK_ClrTxtLine(5);
				LCDK_PrintLine(1,2,5,0);
				calc = EnterValue(1,5,1,1,4,1,Inputs);
				InputCal = calc;
				LCDK_ClrTxtLine(5);
				OpsMode =4;
				break;
			}
			case 42:
			{
				if (ClrLineFlg == 0)
				{
					OpsMode = 4;
					txt[0]='P';
					txt[1]='a';	
					txt[2]='s';
					txt[3]=' ';
					txt[4]='S';
					txt[5]='e';
					txt[6]='l';
					txt[7]='e';
					txt[8]='c';
					txt[9]='t';
					txt[10]='i';
					txt[11]='o';
					txt[12]='n';
					txt[13]=0;
					LCDK_ClrTxtLine(5);
					LCDK_PrintLine(1,0,5,0);
					ClrLineFlg = 1;
				}
				else
				{
					LCDK_ClrTxtLine(5);
					ClrLineFlg = 0;
				}	
				break;
			}
			case 43:
			{
				OpsMode = 4;
				txt[0]='V';
				txt[1]='A';	
				txt[2]='L';
				txt[3]=' ';
				txt[4]='C';
				txt[5]='O';
				txt[6]='U';
				txt[7]='R';
				txt[8]='R';
				txt[9]='A';
				txt[10] = 'N';
				txt[11] = 'T';
				txt[12]=0;
				LCDK_ClrTxtLine(6);
				LCDK_PrintLine(1,0,6,0);
				Current = 1000;
				calc = EnterValue(13,6,4,0,1900,100,1100);	// bug in proc. min= 0, max 2000, def 1000 
				Current = calc;
				LCDK_ClrTxtLine(6);
				break;
			}
			case 44:
			{
				OpsMode = mnstat;
				InitMenu(1);
				break;
			}											
		}	
	}
	RselSWchg = 0;
}	